package org.antlr.tool;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Vector;
import org.antlr.analysis.NFAState;
import org.antlr.grammar.v3.AssignTokenTypesWalker;
import org.antlr.misc.Utils;
import org.antlr.runtime.RecognitionException;
import org.antlr.runtime.tree.CommonTreeNodeStream;
import org.antlr.tool.AssignTokenTypesBehavior;
import org.antlr.tool.CompositeGrammarTree;
import org.antlr.tool.ErrorManager;
import org.antlr.tool.Grammar;
import org.antlr.tool.GrammarAST;
import org.antlr.tool.LeftRecursiveRuleAnalyzer;
import org.antlr.tool.Rule;

public class CompositeGrammar {
  public static final int MIN_RULE_INDEX = 1;
  
  public CompositeGrammarTree delegateGrammarTreeRoot;
  
  protected Set<NFAState> refClosureBusy = new HashSet<NFAState>();
  
  public int stateCounter = 0;
  
  protected Vector<NFAState> numberToStateList = new Vector<NFAState>(1000);
  
  protected int maxTokenType = 3;
  
  public Map<String, Integer> tokenIDToTypeMap = new LinkedHashMap<String, Integer>();
  
  public Map<String, Integer> stringLiteralToTypeMap = new LinkedHashMap<String, Integer>();
  
  public Vector<String> typeToStringLiteralList = new Vector<String>();
  
  public Vector<String> typeToTokenList = new Vector<String>();
  
  protected Set<String> lexerRules = new HashSet<String>();
  
  protected int ruleIndex = 1;
  
  protected Vector<Rule> ruleIndexToRuleList = new Vector<Rule>();
  
  public boolean watchNFAConversion = false;
  
  protected void initTokenSymbolTables() {
    this.typeToTokenList.setSize(10);
    this.typeToTokenList.set(0, "<INVALID>");
    this.typeToTokenList.set(5, "<EOT>");
    this.typeToTokenList.set(3, "<SEMPRED>");
    this.typeToTokenList.set(4, "<SET>");
    this.typeToTokenList.set(2, "<EPSILON>");
    this.typeToTokenList.set(6, "EOF");
    this.typeToTokenList.set(7, "<EOR>");
    this.typeToTokenList.set(8, "DOWN");
    this.typeToTokenList.set(9, "UP");
    this.tokenIDToTypeMap.put("<INVALID>", Utils.integer(-7));
    this.tokenIDToTypeMap.put("<EOT>", Utils.integer(-2));
    this.tokenIDToTypeMap.put("<SEMPRED>", Utils.integer(-4));
    this.tokenIDToTypeMap.put("<SET>", Utils.integer(-3));
    this.tokenIDToTypeMap.put("<EPSILON>", Utils.integer(-5));
    this.tokenIDToTypeMap.put("EOF", Utils.integer(-1));
    this.tokenIDToTypeMap.put("<EOR>", Utils.integer(1));
    this.tokenIDToTypeMap.put("DOWN", Utils.integer(2));
    this.tokenIDToTypeMap.put("UP", Utils.integer(3));
  }
  
  public CompositeGrammar() {
    initTokenSymbolTables();
  }
  
  public CompositeGrammar(Grammar g) {
    this();
    setDelegationRoot(g);
  }
  
  public void setDelegationRoot(Grammar root) {
    this.delegateGrammarTreeRoot = new CompositeGrammarTree(root);
    root.compositeTreeNode = this.delegateGrammarTreeRoot;
  }
  
  public Rule getRule(String ruleName) {
    return this.delegateGrammarTreeRoot.getRule(ruleName);
  }
  
  public Object getOption(String key) {
    return this.delegateGrammarTreeRoot.getOption(key);
  }
  
  public void addGrammar(Grammar delegator, Grammar delegate) {
    if (delegator.compositeTreeNode == null)
      delegator.compositeTreeNode = new CompositeGrammarTree(delegator); 
    delegator.compositeTreeNode.addChild(new CompositeGrammarTree(delegate));
    delegate.composite = this;
  }
  
  public Grammar getDelegator(Grammar g) {
    CompositeGrammarTree me = this.delegateGrammarTreeRoot.findNode(g);
    if (me == null)
      return null; 
    if (me.parent != null)
      return me.parent.grammar; 
    return null;
  }
  
  public List<Grammar> getDelegates(Grammar g) {
    CompositeGrammarTree t = this.delegateGrammarTreeRoot.findNode(g);
    if (t == null)
      return null; 
    List<Grammar> grammars = t.getPostOrderedGrammarList();
    grammars.remove(grammars.size() - 1);
    return grammars;
  }
  
  public List<Grammar> getDirectDelegates(Grammar g) {
    CompositeGrammarTree t = this.delegateGrammarTreeRoot.findNode(g);
    List<CompositeGrammarTree> children = t.children;
    if (children == null)
      return null; 
    List<Grammar> grammars = new ArrayList<Grammar>();
    for (int i = 0; children != null && i < children.size(); i++) {
      CompositeGrammarTree child = children.get(i);
      grammars.add(child.grammar);
    } 
    return grammars;
  }
  
  public List<Grammar> getIndirectDelegates(Grammar g) {
    List<Grammar> direct = getDirectDelegates(g);
    List<Grammar> delegates = getDelegates(g);
    if (direct != null)
      delegates.removeAll(direct); 
    return delegates;
  }
  
  public List<Grammar> getDelegators(Grammar g) {
    if (g == this.delegateGrammarTreeRoot.grammar)
      return null; 
    List<Grammar> grammars = new ArrayList<Grammar>();
    CompositeGrammarTree t = this.delegateGrammarTreeRoot.findNode(g);
    CompositeGrammarTree p = t.parent;
    while (p != null) {
      grammars.add(0, p.grammar);
      p = p.parent;
    } 
    return grammars;
  }
  
  public Set<? extends Rule> getDelegatedRules(Grammar g) {
    if (g != this.delegateGrammarTreeRoot.grammar)
      return null; 
    Set<? extends Rule> rules = getAllImportedRules(g);
    for (Iterator<? extends Rule> it = rules.iterator(); it.hasNext(); ) {
      Rule r = it.next();
      Rule localRule = g.getLocallyDefinedRule(r.name);
      if (localRule != null || r.isSynPred)
        it.remove(); 
    } 
    return rules;
  }
  
  public Set<? extends Rule> getAllImportedRules(Grammar g) {
    Set<String> ruleNames = new HashSet<String>();
    Set<Rule> rules = new HashSet<Rule>();
    CompositeGrammarTree subtreeRoot = this.delegateGrammarTreeRoot.findNode(g);
    List<Grammar> grammars = subtreeRoot.getPreOrderedGrammarList();
    for (int i = 0; i < grammars.size(); i++) {
      Grammar delegate = grammars.get(i);
      for (Rule r : delegate.getRules()) {
        if (!ruleNames.contains(r.name)) {
          ruleNames.add(r.name);
          rules.add(r);
        } 
      } 
    } 
    return rules;
  }
  
  public Grammar getRootGrammar() {
    if (this.delegateGrammarTreeRoot == null)
      return null; 
    return this.delegateGrammarTreeRoot.grammar;
  }
  
  public Grammar getGrammar(String grammarName) {
    CompositeGrammarTree t = this.delegateGrammarTreeRoot.findNode(grammarName);
    if (t != null)
      return t.grammar; 
    return null;
  }
  
  public int getNewNFAStateNumber() {
    return this.stateCounter++;
  }
  
  public void addState(NFAState state) {
    this.numberToStateList.setSize(state.stateNumber + 1);
    this.numberToStateList.set(state.stateNumber, state);
  }
  
  public NFAState getState(int s) {
    return this.numberToStateList.get(s);
  }
  
  public void assignTokenTypes() throws RecognitionException {
    AssignTokenTypesWalker ttypesWalker = new AssignTokenTypesBehavior();
    List<Grammar> grammars = this.delegateGrammarTreeRoot.getPostOrderedGrammarList();
    for (int i = 0; grammars != null && i < grammars.size(); i++) {
      Grammar g = grammars.get(i);
      ttypesWalker.setTreeNodeStream(new CommonTreeNodeStream(g.getGrammarTree()));
      try {
        ttypesWalker.grammar_(g);
      } catch (RecognitionException re) {
        ErrorManager.error(15, re);
      } 
    } 
    ttypesWalker.defineTokens(this.delegateGrammarTreeRoot.grammar);
  }
  
  public void translateLeftRecursiveRules() {
    List<Grammar> grammars = this.delegateGrammarTreeRoot.getPostOrderedGrammarList();
    for (int i = 0; grammars != null && i < grammars.size(); i++) {
      Grammar g = grammars.get(i);
      if (g.type == 2 || g.type == 4)
        for (GrammarAST r : g.grammarTree.findAllType(79)) {
          if (!Character.isUpperCase(r.getChild(0).getText().charAt(0)) && 
            LeftRecursiveRuleAnalyzer.hasImmediateRecursiveRuleRefs(r, r.enclosingRuleName))
            g.translateLeftRecursiveRule(r); 
        }  
    } 
  }
  
  public void defineGrammarSymbols() {
    this.delegateGrammarTreeRoot.trimLexerImportsIntoCombined();
    List<Grammar> grammars = this.delegateGrammarTreeRoot.getPostOrderedGrammarList();
    int i;
    for (i = 0; grammars != null && i < grammars.size(); i++) {
      Grammar g = grammars.get(i);
      g.defineGrammarSymbols();
    } 
    for (i = 0; grammars != null && i < grammars.size(); i++) {
      Grammar g = grammars.get(i);
      g.checkNameSpaceAndActions();
    } 
    minimizeRuleSet();
  }
  
  public void createNFAs() {
    if (ErrorManager.doNotAttemptAnalysis())
      return; 
    List<Grammar> grammars = this.delegateGrammarTreeRoot.getPostOrderedGrammarList();
    int i;
    for (i = 0; grammars != null && i < grammars.size(); i++) {
      Grammar g = grammars.get(i);
      g.createRuleStartAndStopNFAStates();
    } 
    for (i = 0; grammars != null && i < grammars.size(); i++) {
      Grammar g = grammars.get(i);
      g.buildNFA();
    } 
  }
  
  public void minimizeRuleSet() {
    Set<String> ruleDefs = new HashSet<String>();
    _minimizeRuleSet(ruleDefs, this.delegateGrammarTreeRoot);
  }
  
  public void _minimizeRuleSet(Set<String> ruleDefs, CompositeGrammarTree p) {
    Set<String> localRuleDefs = new HashSet<String>();
    Set<String> overrides = new HashSet<String>();
    for (Rule r : p.grammar.getRules()) {
      if (!ruleDefs.contains(r.name)) {
        localRuleDefs.add(r.name);
        continue;
      } 
      if (!r.name.equals("Tokens"))
        overrides.add(r.name); 
    } 
    p.grammar.overriddenRules = overrides;
    ruleDefs.addAll(localRuleDefs);
    if (p.children != null)
      for (CompositeGrammarTree delegate : p.children)
        _minimizeRuleSet(ruleDefs, delegate);  
  }
}
